"""
DOM zpracovani dokumentu:
Program zjisti jmena vsech druhu ovoce z xml dokumentu, ktery
je zadan jako parametr v prikazove radce, a uklada je do seznamu
a tiskne na standardni vystup.
"""

#import modulu pro praci se vstupem a vystupem, s retezci
import sys, string
#import modulu pro tvorbu stromove struktury a uzlu stromu
from xml.dom import minidom, Node

nameList = []		#seznam jmen
dataList = []		#seznam pro data v elementu <nazev>


#funkce pro beh programu
def run(inFileName):    
	#standardni vystup                                      
	outFile = sys.stdout
	#parsovani dokumentu a vytvoreni stromove struktury
	doc = minidom.parse(inFileName)
	#nastaveni korene stromu na documentElement
	rootNode = doc.documentElement
	#vytvoreni seznamu elenentu <ovoce>
	ovoce = rootNode.getElementsByTagName("ovoce")
	#test zda je jen jeden
	if len(ovoce) == 1:
		#vytvoreni seznamu elenemtu <polozka>
		items = ovoce[0].getElementsByTagName("polozka")
		#pruchod seznamem
		for item in items:
			#vytvoreni seznamu elenemtu <nazev>
			names = item.getElementsByTagName("nazev")
			#test zda je jen jeden
			if len(names) == 1:
				#vyprazdneni seznamu dataList
				dataList = []
				#pruchod seznamem bezprostrednich nasledovniku elementu <nazev>
				for child in names[0].childNodes:
					#jestlize je nasledovnik typu TEXT_NODE
					if child.nodeType == Node.TEXT_NODE:
						#pokud ano, vloz na konec seznamu
						dataList.append(child.nodeValue)
				#pokud seznam odsahuje polozky
				if dataList:
					#vytvor z nich retezec 
					strName = string.join(dataList)
					#a vloz do seznamu nameList
					nameList.append(strName)
	else:
		outFile.write("Ovoce neni objednane!\n")
	#Tisk seznamu jmen
	printList(outFile, nameList)

#Funkce pro tisk seznamu
def printList(outfile, nameList):
	outfile.write("V objednavce je %d druhu ovoce:\n" % len(nameList))
	for name in nameList:
		outfile.write(" %s\n" %name)

#funkce pro test poctu vstupnich paramentru
def main():
	args = sys.argv[1:]
	if len(args) != 1:
		print 'Pro spusteni zadejte: python dom_elem.py jidlo.xml'
		sys.exit(-1)
	run(args[0])

main()
