'''
Program pro generovani XML soboru z dat ze slovniku.
'''

#Slovnik s daty
order = {
    'ovoce' : [	('0001', 'jablka', '15', 'kg', '20'),
		('0050', 'vino bile', '35', 'kg', '7.5'),
		('0020', 'avokado', '20', 'ks', '15') ],
    'zelenina' : [	('0111', 'zeli', '6', 'kg', '13'),
			('0160', 'okurka hadovka', '12', 'ks', '7'),
			('0150', 'brambory', '8', 'kg', '50') ],
    'pecivo' : [('0231', 'chleb','20', 'ks', '4'),
		('0231', 'bageta', '10', 'ks', '15') ]
    }

#Definivani funkce pro prevod slovniku 'order' do XML souboru 'objednavka.xml'
def make_xml(dic,xmlfile):
	#Funkce vraci retezec odpovidajici elementu <mnozstvi>
	#Parametry funkce:
	# price - hodnota atributu cena
	# unit - hodnota atributu jednotka
	# num  -  hodnota elementu <mnozstvi>
    	def eleMnozstvi(price,unit,num):
		return '<mnozstvi cena="%s" jednotka="%s">%s</mnozstvi>' % (price,unit,num)

	#Funkce vraci retezec odpovidajici elementu <nazev>:
	#Parametry funkce:
	# name - hodnota elementu <nazev>
	def eleNazev(name):
		return '<nazev>%s</nazev>'% name

	#Funkce pro zapis elementu <polozka> 
	#Parametry funkce:
	# seznam - seznam obsahujici informace o polozce
	def elePolozka(seznam):
		#zapis predem definovane struktury elementu <polozka>, vcetne jeho nasledovniku
		xmlfile.write(
'''
		<polozka kod="%s">
			%s
			%s
		</polozka>''' % (seznam[0], eleNazev(seznam[1]), eleMnozstvi(seznam[2], seznam[3], seznam[4])))
	xmlfile.write("	<ovoce>")
	
	#Vraci hodnotu klice 'ovoce', coz je seznam obsahujici jednotlive ovoce
	ovoce = dic.get('ovoce')

	#pruchod seznamem
	for seznam in ovoce:
		#volani funcke pro zapis elementu <polozka>
		elePolozka(seznam)
	xmlfile.write(
'''
	</ovoce>
	<zelenina>''')
	zelenina = dic.get('zelenina')
	
	for seznam in zelenina:
		elePolozka(seznam)
	xmlfile.write(
'''
	</zelenina>
	<pecivo>''')
	pecivo = dic.get('pecivo')
	
	for seznam in pecivo:
		elePolozka(seznam)
	xmlfile.write(
'''
	</pecivo>
</jidlo>''')

#vytvoreni noveho souboru pro zapis
f = file("jidlo.xml","w")
#zapis halvicky XML dokumentu
f.write('<?xml version="1.0" encoding="utf-8"?>\n\n')
f.write('<jidlo>\n')
#volani funkce pro prebod slovniku na XML dokument
make_xml(order, f)
f.close()
