"""
SAX zpracovani dokumentu:
Program zjisti jmena vsech druhu ovoce, jenz jsou prodavana na kg.
Data se ctou ze xml dokumentu, ktery je zadan jako parametr v prikazove radce.
Jmena se ukladaji do seznamu a tisknou na standardni vystup.
"""

#import modulu pro praci se vstupem a vystupem, s retezci
import sys, string
#import sax handleru a parseru
from xml.sax import handler, make_parser

class MySaxDocumentHandler(handler.ContentHandler):
	#Konstruktor
	def __init__(self, outfile):
		self.outfile = outfile			#standardni vystup
		self.inOvoce = False			#indikator stavu 
		self.inName = False			#indikatot stavu
		self.nameList = []			#seznam jmen
		self.nameData = []			#seznam obsahuji data elementu
		self.kg = False				#indikator jednotky
	#Funkce pro vraceni seznamu
	def get_nameList(self):
		return self.nameList
	#Funkce pro nastaveni seznamu
	def set_nameList(self, nameList):
		self.interestList = interestList
	#Prekryti metody endDocument(self)
	def endDocument(self):                                       
		print "V objednavce jsou %d druhy ovoce prodavane na kg:" % len(self.nameList)
	#Prekryti metodu startElement(self)
	def startElement(self, name, attrs):
		#zacina element <ovoce>                        
		if name == 'ovoce':
			self.inOvoce = True
		#zacina element <nazev>
		elif name == 'nazev':
			self.inName = True
			self.nameData = []
		#zacina element <mnozstvi>
		elif name == 'mnozstvi':
			#vraci hodnotu atributu jmenem jednotka
			unit = attrs.get("jednotka")
			#test zda se jedna o kg
			if unit == 'kg':
				self.kg = True
	#Prekryti metody endElement(self, name)
	def endElement(self, name):
		#konec elementu <nazev> a soucasne jsme uvnitr elementu <ovoce>
		if name == 'nazev' and self.inOvoce:
			self.inName = False
		#konec elementu <ovoce>
		elif name == 'ovoce':
			self.inOvoce = False
		#konec elementu <polozka> a soucasne jsme uvnitr elementu <ovoce>
		elif name == 'polozka' and self.inOvoce:
			#jestlize je parametr jednotka = kg pak
			if self.kg == True:
				#preved obsah sezmanu nameData na retezec
				x = string.join(self.nameData)
				#vloz do seznamu jmen
				self.nameList.append(x)
				self.kg = False
	#Prekryti metody characters(self, chrs)	
	def characters(self, chrs):                                 
		if self.inOvoce and self.inName:
			self.nameData.append(chrs)	

#Funkce pro tisk seznamu
def printList(nameList):
	for name in nameList:
		print " %s" %name

			
#Funkce pro beh 			
def run(inFileName):
	outFile = sys.stdout
	#vytvoreni instance handleru
	handler = MySaxDocumentHandler(outFile)
	#vytvoreni instance parseru
	parser = make_parser()
	#nastaveni handleru 
	parser.setContentHandler(handler)
	#otevreni souboru pro cteni
	inFile = open(inFileName, 'r')
	#parsovani souboru
	parser.parse(inFile)  
        #volani funkce pro tiskt nameListu
	printList( handler.get_nameList() )                             
	#zatvreni souboru
	inFile.close()
	
#funkce pro test poctu vstupnich paramentru
def main():
	args = sys.argv[1:]				#seznam parametru
	#test spravneho poctu parametru
	if len(args) != 1:
		print 'Pro spusteni zadejte: python sax_atr.py jidlo.xml'
		sys.exit(-1)
	#volani funkce pro beh programu
	run(args[0])	

main()
