"""
SAX zpracovani dokumentu:
Program zjisti jmena vsech druhu ovoce z xml dokumentu, ktery
je zadan jako parametr v prikazove radce, a uklada je do seznamu
a tiskne na standardni vystup.
"""

#import modulu pro praci se vstupem a vystupem, s retezci
import sys, string
#import sax handleru a parseru
from xml.sax import handler, make_parser

#definice nove tridy oddedene od ContentHandler
class MySaxDocumentHandler(handler.ContentHandler):
	#Konstruktor tridy
	def __init__(self, outfile):
		self.outfile = outfile			#standardni vystup
		self.inOvoce = False			#indikator stavu 
		self.inName = False			#indikatot stavu
		self.nameList = []			#seznam jmen
		self.nameData = []			#seznam obsahuji data elementu
	#Funkce pro vraceni seznamu
	def get_nameList(self):
		return self.nameList
	#Funkce pro nastaveni seznamu
	def set_nameList(self, nameList):
		self.nameList = nameList                       
	#Prekryti metody endDocument(self)
	def endDocument(self):                                       
		self.outfile.write( "V objednavce je %d druhu ovoce:\n" % len(self.nameList))
	#Prekryti metodu startElement(self)
	def startElement(self, name, attrs):                        
		if name == 'ovoce':
			self.inOvoce = True
		elif name == 'nazev':
			self.inName = True
			self.nameData = []
	#Prekryti metody endElement(self, name)
	def endElement(self, name):
		#konci element <nazev> a soucasne jsme v elementu ovoce 
		if name == 'nazev' and self.inOvoce:
			#vytvoreni retezce ze seznamu
			x = string.join(self.nameData)
			self.inName = False
			self.nameList.append(x)
		#konci element <ovoce>			
		elif name == 'ovoce':
			self.inOvoce = False
	#Prekryti metody characters(self, chrs)	
	def characters(self, chrs):                                 
		if self.inOvoce and self.inName:
			self.nameData.append(chrs)	

#Funkce pro tisk seznamu
def printList(outfile, nameList):
	for name in nameList:
		outfile.write(" %s\n" %name)

			
#Funkce pro beh 			
def run(inFileName):
	outFile = sys.stdout
	#vytvoreni instance handleru
	handler = MySaxDocumentHandler(outFile)
	#vytvoreni instance parseru
	parser = make_parser()
	#nastaveni handleru 
	parser.setContentHandler(handler)
	#otevreni souboru pro cteni
	inFile = open(inFileName, 'r')
	#parsovani souboru
	parser.parse(inFile) 
	#volani funkce pro tiskt nameListu
	printList(outFile, handler.get_nameList() )                                   
	#zatvreni souboru
	inFile.close()

#funkce pro test poctu vstupnich paramentru
def main():
	args = sys.argv[1:]				#seznam parametru
	#test spravneho poctu parametru
	if len(args) != 1:
		print 'Pro spusteni zadejte: python sax_elem.py jidlo.xml'
		sys.exit(-1)
	#volani funkce pro beh programu
	run(args[0])	

main()
