'''
Prevod TXT na XML bez pouziti knihoven:
Program prevede data ze souboru TXT, ktery ma predem znamou 
strukturou. XML souboru se musi vytvorit podle urcite predepsane 
struktury elementu a atributu. Pro vetsi obtiznost bylo zvolena 
forma s atributy, aby byl priklad nazornejsi. Pri volbe elementu
by stacilo pouze nahradit sekvenci znaku jinou sekvenci, ktera by 
odpovidala nazvu pocatecni a koncove znacky elementu.
'''

import codecs

#pomocne indexy pro dodrzeni preddefinovane struktury
indexes = [0, 2, 1, 3, 4, 5]
#seznam pro ukladani udaju o jednotlivych osobach
people = []

# Funkce se spusti prikazem create_xml(txt, xml), kde
# txt = jmeno textoveho zdrojoveho souboru napr. databaze.txt
# xml = jmeno xml vystupniho souboru napr. databaze.xml
def create_xml(txt, xml):
  file_txt = file(txt, "r")
  file_xml = file(xml, "w")
  
  for line in file_txt:
    line = line.rstrip("\n")
    people.append(line.split(';'))
  
  
  #zapis hlavicky XML dokumentu a znacky korenoveho elementu
  file_xml.write(
'''<?xml version="1.0" encoding="iso-8859-1"?>

<people>
''')
  
  #cyklus spracovavajici jednotlive osoby
  for person in people:
    for ind in indexes:
      if ind == 0:
        file_xml.write(
''' <person id="%s"'''% person[ind])
      elif ind == 2:
        file_xml.write(' sex ="%s">\n'%person[ind])
      elif ind == 1:
        file_xml.write(
'''   <name>%s</name>\n'''%person[ind])
      elif ind == 3:
        file_xml.write(
'''   <mother>%s</mother>\n'''%person[ind])
      elif ind == 4:
        file_xml.write(
'''   <father>%s</father>\n'''%person[ind])
      else:
        file_xml.write(
'''   <partner>%s</partner>
  </person>
  
'''%person[ind])
  file_xml.write("</people>")
  file_xml.close()
  file_txt.close()

#volani funkce s prednastavenymi jmeny souboru
create_xml("../data/databaze.txt", "../data/databaze.xml")

