"""
Validace XML dokumentu proti DTD:
Program otevre xml dokument zadany jako prvni parametr prikazove radky a zvalidujeho proti externimu DTD schematu. Jmeno DTD je druhy parametr spousteciho prikazu.
"""

#import modulu pro praci se vstupem a vystupem
import sys
#import modulu pro reprezentaci stromove struktury a validaci XML
from lxml import etree

#Funkce pro beh programu s parametry:
# xmlName - jmeno XML dokumentu
# dtdName - jmeno DTD schematu
def run(xmlName, dtdName):
	#parsovani XML a vytvoreni stromove struktury
	doc = etree.parse(xmlName)
	#otevreni DTD schematu pro cteni
	dtdfile = file(dtdName, "r")
	#vytvoreni schematu
	dtd = etree.DTD(dtdfile)
	#validace, vysledek je bud True nebo False
	if dtd.validate(doc) == True:
		print "Dokument '%s' je v poradku." %xmlName
	else:
		print dtd.error_log.filter_from_errors()

#Funkce pro test poctu vstupnich paramentru
def main():
	args = sys.argv[1:]
	if len(args) != 2:
		print 'Pro spusteni zadejte: python val_dtd.py jidloDTD.xml jidlo.dtd'
		sys.exit(-1)
	run(args[0], args[1])

main()

